using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace ID3TagEditLite {
    public partial class FormPreferencesDlg : Form {
        SortedList<int, string> cpList = new SortedList<int, string>();

        public FormPreferencesDlg() {
            InitializeComponent();
            if (Program.thePref.applyFontToDialog) {
                Font = new Font(Program.thePref.fontFamily, Program.thePref.fontSize);
            }
            else {
                Font = System.Drawing.SystemFonts.MessageBoxFont;
            }
            CultureInfo[] cts = CultureInfo.GetCultures(CultureTypes.NeutralCultures);
            foreach (CultureInfo ct in cts) {
                int cp = ct.TextInfo.ANSICodePage;
                if (cp != 0 && cpList.ContainsKey(cp) == false) {
                    Encoding enc = Encoding.GetEncoding(cp);
                    string name = "CP" + cp.ToString() + " / " + enc.WebName.ToUpper() + " / " + enc.EncodingName;
                    cpList.Add(cp, name);
                }
            }
            foreach (string name in cpList.Values) {
                cbxCodePage.Items.Add(name);
            }
            if (cpList.ContainsKey(Program.thePref.ansiCodePage)) {
                cbxCodePage.SelectedIndex = cpList.Keys.IndexOf(Program.thePref.ansiCodePage);
            }
            chkNothingIsAll.Checked = Program.thePref.nothingIsAll;
            chkAutoAppendCoverImage.Checked = Program.thePref.autoAppendCoverImage;
            chkApplyFontToDialog.Checked = Program.thePref.applyFontToDialog;
        }

        private void btnOK_Click(object sender, EventArgs e) {
            Program.thePref.ansiCodePage = cpList.Keys[cbxCodePage.SelectedIndex];
            Program.thePref.nothingIsAll = chkNothingIsAll.Checked;
            Program.thePref.autoAppendCoverImage = chkAutoAppendCoverImage.Checked;
            Program.thePref.applyFontToDialog = chkApplyFontToDialog.Checked;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e) {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}