using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
/*
struct ID3_V1 {
	char tag[3];
	char title[30];
	char artist[30];
	char album[30];
	char year[4];
	union {
		struct {
			char comment[30];
		}
		v10;
		struct {
			char comment[28];
			char zero;
			char track;
		}
		v11;
	} u;
	char m_genre;
};
*/
namespace ID3TagEditLite {
    class TID3V1Tag {
        public const int TAG_SIZE = 128;

        public byte[] magic;
        public byte[] title;
        public byte[] artist;
        public byte[] album;
        public byte[] year;
        public byte[] comment;
        public byte zero = 0x20;
        public byte track = 0;
        public byte genre = 0;
        
        public bool Read(BinaryReader br) {
            magic = br.ReadBytes(3);
            ASCIIEncoding ae = new ASCIIEncoding();
            if (ae.GetString(magic).Equals("TAG") == false)
                return false;
            title = br.ReadBytes(30);
            artist = br.ReadBytes(30);
            album = br.ReadBytes(30);
            year = br.ReadBytes(4);
            long pos = br.BaseStream.Position;
            comment = br.ReadBytes(28);
            zero = br.ReadByte();
            if (zero == 0) {
                // V11
                track = br.ReadByte();
            }
            else {
                // V10
                br.BaseStream.Seek(pos, SeekOrigin.Begin);
                comment = br.ReadBytes(30);
            }
            genre = br.ReadByte();
            return true;
        }
    }
}
