using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;

namespace ID3TagEditLite {
    /// <summary>
    /// ^OB
    /// </summary>
    public class TTagString {
        // BOM
        public const char CHAR_BOM_BIG_ENDIAN = (char)0xFFFE;
        public const char CHAR_BOM_LITTLE_ENDIAN = (char)0xFEFF;
        //
        public byte[] original = new byte[0];
        public TTagEncoding encoding = TTagEncoding.ANSI;
        public string str = "";

        public TTagString Clone() {
            TTagString s = new TTagString();
            if (original != null)
                s.original = (byte[])original.Clone();
            s.str = str;
            s.encoding = encoding;
            return s;
        }

        public void Set(byte[] data, int offset, int byteCount, TTagEncoding encoding) {
            if (byteCount > 0) {
                original = new byte[byteCount];
                Array.Copy(data, offset, original, 0, byteCount);
            }
            else {
                original = new byte[0];
            }
            this.encoding = encoding;
        }

        // m_org -> m_str
        public bool DecodeString(/*TTagEncoding code*/) {
            if (original.Length == 0) {
                str = "";
                encoding = TTagEncoding.ANSI;
                return false;
            }

            char[] trimChar = new char[] { '\0', ' ' };
            char[] uniTrimChar = new char[] { '\0', ' ', CHAR_BOM_BIG_ENDIAN, CHAR_BOM_LITTLE_ENDIAN };

            // iTunes̍^O͂̕ȂŌNULL܂ޒݒ肳ĂB
            // ĐƂĈɂ͂NULL폜KvB
            // dl͂NULLI[Kv͂ȂB
            if (encoding == TTagEncoding.UTF16 && original.Length >= 2) {
                UnicodeEncoding ue = new UnicodeEncoding();
                str = ue.GetString(original).Trim(uniTrimChar);
                if (str.Length == 1 && (str[0] == CHAR_BOM_BIG_ENDIAN || str[0] == CHAR_BOM_LITTLE_ENDIAN))
                    str = "";
            }
            // 1傫Ƃ肾Â߂͕sBssȃf[^\͂Ȃ͂ȂB
            // ꉞlςȃf[^͒eƂɂB
            //else if (m_org.Length > 1) {
            else if (original.Length == 0 || (original.Length == 1 && original[0] == 0)) {
                str = "";
                encoding = TTagEncoding.ANSI;
            }
            else {
                Encoding enc = Encoding.GetEncoding(Program.thePref.ansiCodePage);
                str = enc.GetString(original).Trim(trimChar);
                encoding = TTagEncoding.ANSI;
            }
            return false;
        }

        public String GetDecodeString() {
            DecodeString();
            return str;
        }

        // m_str -> m_org
        public void EncodeString(TTagEncoding code, int limit) {
            if (str.Length == 0) {
                if (original.Length > 0)
                    original = new byte[0];
                encoding = TTagEncoding.ANSI;
                return;
            }

            if (code == TTagEncoding.UTF16) {
                UnicodeEncoding ue = new UnicodeEncoding(false, true);
                original = TTools.UnionByteArray(ue.GetPreamble(), ue.GetBytes(str));
                encoding = TTagEncoding.UTF16;
            }
            else {
                Encoding enc = Encoding.GetEncoding(Program.thePref.ansiCodePage);
                original = enc.GetBytes(str);
                encoding = TTagEncoding.ANSI;
            }
            if (limit > 0 && original.Length > limit) {
                byte[] o = new byte[limit];
                Array.Copy(original, 0, o, 0, limit);
                original = o;
            }
        }

        public TTagEncoding CheckString() {
            TTagEncoding decodeAs = TTagEncoding.ANSI;
            if (original.Length == 0)
                return decodeAs;

            // Macintosh ł͂ɗLATIN1GR[h̔肪B
            // Windowsł͕svƎvB
            // ēʎ͂ȂB

            return decodeAs;
        }

    }

}
